/* This program finds the four network/host information blocks
   in an IP address.

   Input:  an IP address
   Output: four network/host information blocks, or an error message
--------------------------------------------------------------------*/

#include <iostream>        // cin, cout
#include <string>          // string class
#include <cassert>         // assert()
using namespace std;

int main()
{
  string address, block1, block2, block3, block4;

  cout << "Enter an IP address: ";
  cin >> address;

  // Search address to find first period -- start at position 0
  int dot1 = address.find(".", 0);
  assert(dot1 != string::npos);
  // Period found; set block1 = substring preceding it
  block1 = address.substr(0, dot1);

  // Search address for second period -- start at position dot1 + 1
  int dot2 = address.find(".", dot1 + 1);
  assert(dot2 != string::npos);
  // 2nd period found; set block2 = substring between 1st and 2nd
  block2 = address.substr(dot1 + 1, dot2 - dot1 - 1);

  // Search address for third period -- start at position dot2 + 1
  int dot3 = address.find(".", dot2 + 1);
  assert(dot3 != string::npos);
  // 3rd period found; set block3 = substring between 2nd and 3rd
  block3 = address.substr(dot2 + 1, dot3 - dot2 - 1);

  // Check for more periods
  assert(address.find(".", dot3 + 1) == string::npos);
  // No more periods; set block4 = rest of address after 3rd one
  block4 = address.substr(dot3 + 1, address.size() - dot3 - 1);

  cout << "The network/host blocks are:\n"
       << block1 << endl << block2 << endl
       << block3 << endl << block4 << endl;
}
